Index: branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90
===================================================================
--- branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90	(revision 7308)
+++ branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90	(revision 7309)
@@ -24,5 +24,4 @@
    USE ice             ! LIM-3: ice variables
    USE thd_ice         ! LIM-3: thermodynamical variables
-   USE dom_ice         ! LIM-3: ice domain
    !
    USE sbc_oce         ! Surface boundary condition: ocean fields
@@ -31,4 +30,5 @@
    USE sbcblk_clio     ! Surface boundary condition: CLIO bulk
    USE sbccpl          ! Surface boundary condition: coupled interface
+   USE sbcana          ! Surface boundary condition: analytic formulation
    USE albedo          ! ocean & ice albedo
    !
@@ -48,5 +48,4 @@
    USE limvar          ! Ice variables switch
    USE limctl          ! 
-   USE limmsh          ! LIM mesh
    USE limistate       ! LIM initial state
    USE limthd_sal      ! LIM ice thermodynamics: salinity
@@ -65,4 +64,9 @@
    USE bdyice_lim       ! unstructured open boundary data  (bdy_ice_lim routine)
 #endif
+# if defined key_agrif
+   USE agrif_ice
+   USE agrif_lim3_update
+   USE agrif_lim3_interp
+# endif
 
    IMPLICIT NONE
@@ -102,7 +106,7 @@
       !!---------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt      ! ocean time step
-      INTEGER, INTENT(in) ::   kblk    ! type of bulk (=3 CLIO, =4 CORE, =5 COUPLED)
-      !!
-      INTEGER  ::    jl                 ! dummy loop index
+      INTEGER, INTENT(in) ::   kblk    ! type of bulk (=1 ANALYTIC, =3 CLIO, =4 CORE, =5 COUPLED)
+      !!
+      INTEGER  ::   jl                 ! dummy loop index
       REAL(wp), POINTER, DIMENSION(:,:,:)   ::   zalb_os, zalb_cs  ! ice albedo under overcast/clear sky
       REAL(wp), POINTER, DIMENSION(:,:  )   ::   zutau_ice, zvtau_ice 
@@ -110,4 +114,11 @@
 
       IF( nn_timing == 1 )  CALL timing_start('sbc_ice_lim')
+
+      ! clem: it is important to initialize agrif_lim3 variables here and not in sbc_lim_init
+# if defined key_agrif
+      IF( kt == nit000 ) THEN
+         IF( .NOT. Agrif_Root() )   CALL Agrif_InitValues_cont_lim3
+      ENDIF
+# endif
 
       !-----------------------!
@@ -115,4 +126,8 @@
       !-----------------------!
       IF( MOD( kt-1, nn_fsbc ) == 0 ) THEN
+
+# if defined key_agrif
+         IF( .NOT. Agrif_Root() )  lim_nbstep = MOD( lim_nbstep, Agrif_irhot() * Agrif_Parent(nn_fsbc) / nn_fsbc ) + 1
+# endif
 
          ! mean surface ocean current at ice velocity point (C-grid dynamics :  U- & V-points as the ocean)
@@ -136,12 +151,13 @@
          !-----------------------------------------------------------------
          SELECT CASE( kblk )
-         CASE( jp_clio    )   ;   CALL blk_ice_clio_tau                         ! CLIO bulk formulation            
-         CASE( jp_core    )   ;   CALL blk_ice_core_tau                         ! CORE bulk formulation
-         CASE( jp_purecpl )   ;   CALL sbc_cpl_ice_tau( utau_ice , vtau_ice )   ! Coupled   formulation
+            CASE( jp_ana     )   ;    CALL ana_ice_tau                              ! analytic formulation            
+            CASE( jp_clio    )   ;    CALL blk_ice_clio_tau                         ! CLIO bulk formulation            
+            CASE( jp_core    )   ;    CALL blk_ice_core_tau                         ! CORE bulk formulation
+            CASE( jp_purecpl )   ;    CALL sbc_cpl_ice_tau( utau_ice , vtau_ice )   ! Coupled   formulation
          END SELECT
          
-         IF( ln_mixcpl) THEN   ! Case of a mixed Bulk/Coupled formulation
+         IF( ln_mixcpl) THEN                                                       ! Case of a mixed Bulk/Coupled formulation
             CALL wrk_alloc( jpi,jpj    , zutau_ice, zvtau_ice)
-            CALL sbc_cpl_ice_tau( zutau_ice , zvtau_ice )
+                                      CALL sbc_cpl_ice_tau( zutau_ice , zvtau_ice )
             utau_ice(:,:) = utau_ice(:,:) * xcplmask(:,:,0) + zutau_ice(:,:) * ( 1. - xcplmask(:,:,0) )
             vtau_ice(:,:) = vtau_ice(:,:) * xcplmask(:,:,0) + zvtau_ice(:,:) * ( 1. - xcplmask(:,:,0) )
@@ -154,29 +170,37 @@
          numit = numit + nn_fsbc                  ! Ice model time step
          !                                                   
-         CALL sbc_lim_bef                         ! Store previous ice values
-         CALL sbc_lim_diag0                       ! set diag of mass, heat and salt fluxes to 0
-         CALL lim_rst_opn( kt )                   ! Open Ice restart file
-         !
-         IF( .NOT. lk_c1d ) THEN
+                                      CALL sbc_lim_bef         ! Store previous ice values
+                                      CALL sbc_lim_diag0       ! set diag of mass, heat and salt fluxes to 0
+                                      CALL lim_rst_opn( kt )   ! Open Ice restart file
+         !
+         ! --- zap this if no ice dynamics --- !
+         IF( .NOT. lk_c1d .AND. ln_limdyn ) THEN
             !
-            CALL lim_dyn( kt )                    ! Ice dynamics    ( rheology/dynamics )   
-            !
-            CALL lim_trp( kt )                    ! Ice transport   ( Advection/diffusion )
-            !
-            IF( nn_monocat /= 2 ) CALL lim_itd_me ! Mechanical redistribution ! (ridging/rafting)
-            !
-#if defined key_bdy
-            CALL bdy_ice_lim( kt )                ! bdy ice thermo 
-            IF( ln_icectl )       CALL lim_prt( kt, iiceprt, jiceprt, 1, ' - ice thermo bdy - ' )
-#endif
-            !
-            CALL lim_update1( kt )                ! Corrections
+            IF( nn_limdyn /= 0 ) THEN                          ! -- Ice dynamics
+                                      CALL lim_dyn( kt )       !     rheology  
+            ELSE
+               u_ice(:,:) = rn_uice * umask(:,:,1)             !     or prescribed velocity
+               v_ice(:,:) = rn_vice * vmask(:,:,1)
+            ENDIF
+                                      CALL lim_trp( kt )       ! -- Ice transport (Advection/diffusion)
+            IF( nn_limdyn == 2 .AND. nn_monocat /= 2 )  &      ! -- Mechanical redistribution (ridging/rafting)
+               &                      CALL lim_itd_me         
+            IF( nn_limdyn == 2 )      CALL lim_update1( kt )   ! -- Corrections
             !
          ENDIF
-         
+
+         ! ---
+#if defined key_agrif
+         IF( .NOT. Agrif_Root() )     CALL agrif_interp_lim3('T')
+#endif
+#if defined key_bdy
+         IF( ln_limthd )              CALL bdy_ice_lim( kt )   ! -- bdy ice thermo 
+#endif
+
          ! previous lead fraction and ice volume for flux calculations
-         CALL sbc_lim_bef                        
-         CALL lim_var_glo2eqv                     ! ht_i and ht_s for ice albedo calculation
-         CALL lim_var_agg(1)                      ! at_i for coupling (via pfrld) 
+                                      CALL sbc_lim_bef                        
+                                      CALL lim_var_glo2eqv     ! ht_i and ht_s for ice albedo calculation
+                                      CALL lim_var_agg(1)      ! at_i for coupling (via pfrld) 
+         !
          pfrld(:,:)   = 1._wp - at_i(:,:)
          phicif(:,:)  = vt_i(:,:)
@@ -193,25 +217,33 @@
          !----------------------------------------------------------------------------------------
          CALL wrk_alloc( jpi,jpj,jpl, zalb_os, zalb_cs )
-         CALL albedo_ice( t_su, ht_i, ht_s, zalb_cs, zalb_os ) ! cloud-sky and overcast-sky ice albedos
-
+         
+                                      CALL albedo_ice( t_su, ht_i, ht_s, zalb_cs, zalb_os ) ! cloud-sky and overcast-sky ice albedos
          SELECT CASE( kblk )
-         CASE( jp_clio )                                       ! CLIO bulk formulation
-            ! In CLIO the cloud fraction is read in the climatology and the all-sky albedo 
-            ! (alb_ice) is computed within the bulk routine
-                                 CALL blk_ice_clio_flx( t_su, zalb_cs, zalb_os, alb_ice )
-            IF( ln_mixcpl      ) CALL sbc_cpl_ice_flx( p_frld=pfrld, palbi=alb_ice, psst=sst_m, pist=t_su )
-            IF( nn_limflx /= 2 ) CALL ice_lim_flx( t_su, alb_ice, qns_ice, qsr_ice, dqns_ice, evap_ice, devap_ice, nn_limflx )
-         CASE( jp_core )                                       ! CORE bulk formulation
-            ! albedo depends on cloud fraction because of non-linear spectral effects
-            alb_ice(:,:,:) = ( 1. - cldf_ice ) * zalb_cs(:,:,:) + cldf_ice * zalb_os(:,:,:)
-                                 CALL blk_ice_core_flx( t_su, alb_ice )
-            IF( ln_mixcpl      ) CALL sbc_cpl_ice_flx( p_frld=pfrld, palbi=alb_ice, psst=sst_m, pist=t_su )
-            IF( nn_limflx /= 2 ) CALL ice_lim_flx( t_su, alb_ice, qns_ice, qsr_ice, dqns_ice, evap_ice, devap_ice, nn_limflx )
-         CASE ( jp_purecpl )
-            ! albedo depends on cloud fraction because of non-linear spectral effects
-            alb_ice(:,:,:) = ( 1. - cldf_ice ) * zalb_cs(:,:,:) + cldf_ice * zalb_os(:,:,:)
-                                 CALL sbc_cpl_ice_flx( p_frld=pfrld, palbi=alb_ice, psst=sst_m, pist=t_su )
-            IF( nn_limflx == 2 ) CALL ice_lim_flx( t_su, alb_ice, qns_ice, qsr_ice, dqns_ice, evap_ice, devap_ice, nn_limflx )
+
+            CASE( jp_ana )                                        ! analytic formulation
+                                      CALL ana_ice_flx
+               
+            CASE( jp_clio )                                       ! CLIO bulk formulation
+               ! In CLIO the cloud fraction is read in the climatology and the all-sky albedo 
+               ! (alb_ice) is computed within the bulk routine
+                                      CALL blk_ice_clio_flx( t_su, zalb_cs, zalb_os, alb_ice )
+               IF( ln_mixcpl      )   CALL sbc_cpl_ice_flx( p_frld=pfrld, palbi=alb_ice, psst=sst_m, pist=t_su )
+               IF( nn_limflx /= 2 )   CALL ice_lim_flx( t_su, alb_ice, qns_ice, qsr_ice, dqns_ice, evap_ice, devap_ice, nn_limflx )
+               
+            CASE( jp_core )                                       ! CORE bulk formulation
+               ! albedo depends on cloud fraction because of non-linear spectral effects
+               alb_ice(:,:,:) = ( 1. - cldf_ice ) * zalb_cs(:,:,:) + cldf_ice * zalb_os(:,:,:)
+                                      CALL blk_ice_core_flx( t_su, alb_ice )
+               IF( ln_mixcpl      )   CALL sbc_cpl_ice_flx( p_frld=pfrld, palbi=alb_ice, psst=sst_m, pist=t_su )
+               IF( nn_limflx /= 2 )   CALL ice_lim_flx( t_su, alb_ice, qns_ice, qsr_ice, dqns_ice, evap_ice, devap_ice, nn_limflx )
+               
+            CASE ( jp_purecpl )                                    ! Coupled formulation
+               ! albedo depends on cloud fraction because of non-linear spectral effects
+               alb_ice(:,:,:) = ( 1. - cldf_ice ) * zalb_cs(:,:,:) + cldf_ice * zalb_os(:,:,:)
+                                      CALL sbc_cpl_ice_flx( p_frld=pfrld, palbi=alb_ice, psst=sst_m, pist=t_su )
+               IF( nn_limflx == 2 )   CALL ice_lim_flx( t_su, alb_ice, qns_ice, qsr_ice, dqns_ice, evap_ice, devap_ice, nn_limflx )
+
          END SELECT
+
          CALL wrk_dealloc( jpi,jpj,jpl, zalb_os, zalb_cs )
 
@@ -219,20 +251,31 @@
          ! --- ice thermodynamics --- !
          !----------------------------!
-         CALL lim_thd( kt )                         ! Ice thermodynamics      
-         !
-         CALL lim_update2( kt )                     ! Corrections
-         !
-         CALL lim_sbc_flx( kt )                     ! Update surface ocean mass, heat and salt fluxes
-         !
-         IF(ln_limdiaout) CALL lim_diahsb           ! Diagnostics and outputs 
-         !
-         CALL lim_wri( 1 )                          ! Ice outputs 
+         ! --- zap this if no ice thermo --- !
+         IF( ln_limthd )              CALL lim_thd( kt )        ! -- Ice thermodynamics      
+         IF( ln_limthd )              CALL lim_update2( kt )    ! -- Corrections
+         ! ---
+# if defined key_agrif
+         IF( .NOT. Agrif_Root() )     CALL agrif_update_lim3( kt )
+# endif
+                                      CALL lim_var_glo2eqv      ! necessary calls (at least for coupling)
+                                      CALL lim_var_agg( 2 )     ! necessary calls (at least for coupling)
+                                      !
+# if defined key_agrif
+!!         IF( .NOT. Agrif_Root() )     CALL Agrif_ChildGrid_To_ParentGrid()  ! clem: should be called at the update frequency only (cf agrif_lim3_update)
+# endif
+                                      CALL lim_sbc_flx( kt )    ! -- Update surface ocean mass, heat and salt fluxes
+# if defined key_agrif
+!!         IF( .NOT. Agrif_Root() )     CALL Agrif_ParentGrid_To_ChildGrid()  ! clem: should be called at the update frequency only (cf agrif_lim3_update)
+# endif
+         IF( ln_limdiahsb )           CALL lim_diahsb( kt )     ! -- Diagnostics and outputs 
+         !
+                                      CALL lim_wri( 1 )         ! -- Ice outputs 
          !
          IF( kt == nit000 .AND. ln_rstart )   &
-            &             CALL iom_close( numrir )  ! close input ice restart file
-         !
-         IF( lrst_ice )   CALL lim_rst_write( kt )  ! Ice restart file 
-         !
-         IF( ln_icectl )  CALL lim_ctl( kt )        ! alerts in case of model crash
+            &                         CALL iom_close( numrir )  ! close input ice restart file
+         !
+         IF( lrst_ice )               CALL lim_rst_write( kt )  ! -- Ice restart file 
+         !
+         IF( ln_limctl )              CALL lim_ctl( kt )        ! alerts in case of model crash
          !
       ENDIF   ! End sea-ice time step only
@@ -242,5 +285,6 @@
       !-------------------------!
       ! Update surface ocean stresses (only in ice-dynamic case) otherwise the atm.-ocean stresses are used everywhere
-      IF( ln_limdyn )     CALL lim_sbc_tau( kt, ub(:,:,1), vb(:,:,1) )  ! using before instantaneous surf. currents
+      !    using before instantaneous surf. currents
+      IF( ln_limdyn )                 CALL lim_sbc_tau( kt, ub(:,:,1), vb(:,:,1) )
 !!gm   remark, the ocean-ice stress is not saved in ice diag call above .....  find a solution!!!
       !
@@ -259,5 +303,5 @@
       !!----------------------------------------------------------------------
       IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) 'sbc_ice_lim : update ocean surface boudary condition' 
+      IF(lwp) WRITE(numout,*) 'sbc_lim_init : update ocean surface boudary condition' 
       IF(lwp) WRITE(numout,*) '~~~~~~~~~~~   via Louvain la Neuve Ice Model (LIM-3) time stepping'
       !
@@ -271,17 +315,12 @@
       !                                ! Allocate the ice arrays
       ierr =        ice_alloc        ()      ! ice variables
-      ierr = ierr + dom_ice_alloc    ()      ! domain
       ierr = ierr + sbc_ice_alloc    ()      ! surface forcing
       ierr = ierr + thd_ice_alloc    ()      ! thermodynamics
-      ierr = ierr + lim_itd_me_alloc ()      ! ice thickness distribution - mechanics
+      IF( ln_limdyn )   ierr = ierr + lim_itd_me_alloc ()      ! ice thickness distribution - mechanics
       !
       IF( lk_mpp    )   CALL mpp_sum( ierr )
       IF( ierr /= 0 )   CALL ctl_stop('STOP', 'sbc_lim_init : unable to allocate ice arrays')
       !
-      !                                ! adequation jpk versus ice/snow layers/categories
-      IF( jpl > jpk .OR. (nlay_i+1) > jpk .OR. nlay_s > jpk )   &
-         &      CALL ctl_stop( 'STOP',                          &
-         &     'sbc_lim_init: the 3rd dimension of workspace arrays is too small.',   &
-         &     'use more ocean levels or less ice/snow layers/categories.' )
+      CALL lim_dyn_init                ! set ice dynamics parameters
       !
       CALL lim_itd_init                ! ice thickness distribution initialization
@@ -293,7 +332,5 @@
       CALL lim_thd_sal_init            ! set ice salinity parameters
       !
-      CALL lim_msh                     ! ice mesh initialization
-      !
-      CALL lim_itd_me_init             ! ice thickness distribution initialization for mecanical deformation
+      IF( ln_limdyn )   CALL lim_itd_me_init             ! ice thickness distribution initialization for mecanical deformation
       !                                ! Initial sea-ice state
       IF( .NOT. ln_rstart ) THEN              ! start from rest: sea-ice deduced from sst
@@ -305,8 +342,10 @@
          numit = nit000 - 1
       ENDIF
-      CALL lim_var_agg(1)
+      CALL lim_var_agg(2)
       CALL lim_var_glo2eqv
       !
       CALL lim_sbc_init                 ! ice surface boundary condition   
+      !
+      IF( ln_limdiahsb) CALL lim_diahsb_init  ! initialization for diags
       !
       fr_i(:,:)     = at_i(:,:)         ! initialisation of sea-ice fraction
@@ -342,16 +381,26 @@
       !!-------------------------------------------------------------------
       INTEGER  ::   ios                 ! Local integer output status for namelist read
-      NAMELIST/namicerun/ jpl, nlay_i, nlay_s, cn_icerst_in, cn_icerst_indir, cn_icerst_out, cn_icerst_outdir,  &
-         &                ln_limdyn, rn_amax_n, rn_amax_s, ln_limdiahsb, ln_limdiaout, ln_icectl, iiceprt, jiceprt  
+      NAMELIST/namicerun/ jpl, nlay_i, nlay_s, rn_amax_n, rn_amax_s, cn_icerst_in, cn_icerst_indir,   &
+         &                cn_icerst_out, cn_icerst_outdir, ln_limthd, ln_limdyn, nn_limdyn, rn_uice, rn_vice  
+      NAMELIST/namicediag/ ln_limdiachk, ln_limdiahsb, ln_limctl, iiceprt, jiceprt  
       !!-------------------------------------------------------------------
       !                    
       REWIND( numnam_ice_ref )              ! Namelist namicerun in reference namelist : Parameters for ice
       READ  ( numnam_ice_ref, namicerun, IOSTAT = ios, ERR = 901)
-901   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namicerun in reference namelist', lwp )
-      !
+901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namicerun in reference namelist', lwp )
+
       REWIND( numnam_ice_cfg )              ! Namelist namicerun in configuration namelist : Parameters for ice
       READ  ( numnam_ice_cfg, namicerun, IOSTAT = ios, ERR = 902 )
-902   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namicerun in configuration namelist', lwp )
-      IF(lwm) WRITE( numoni, namicerun )
+902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namicerun in configuration namelist', lwp )
+      IF(lwm) WRITE ( numoni, namicerun )
+      !
+      REWIND( numnam_ice_ref )              ! Namelist namicediag in reference namelist : Parameters for ice
+      READ  ( numnam_ice_ref, namicediag, IOSTAT = ios, ERR = 903)
+903   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namicediag in reference namelist', lwp )
+
+      REWIND( numnam_ice_cfg )              ! Namelist namicediag in configuration namelist : Parameters for ice
+      READ  ( numnam_ice_cfg, namicediag, IOSTAT = ios, ERR = 904 )
+904   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namicediag in configuration namelist', lwp )
+      IF(lwm) WRITE ( numoni, namicediag )
       !
       IF(lwp) THEN                        ! control print
@@ -362,16 +411,26 @@
          WRITE(numout,*) '   number of ice  layers                                   = ', nlay_i
          WRITE(numout,*) '   number of snow layers                                   = ', nlay_s
-         WRITE(numout,*) '   switch for ice dynamics (1) or not (0)      ln_limdyn   = ', ln_limdyn
          WRITE(numout,*) '   maximum ice concentration for NH                        = ', rn_amax_n 
          WRITE(numout,*) '   maximum ice concentration for SH                        = ', rn_amax_s
-         WRITE(numout,*) '   Diagnose heat/salt budget or not          ln_limdiahsb  = ', ln_limdiahsb
-         WRITE(numout,*) '   Output   heat/salt budget or not          ln_limdiaout  = ', ln_limdiaout
-         WRITE(numout,*) '   control prints in ocean.out for (i,j)=(iiceprt,jiceprt) = ', ln_icectl
-         WRITE(numout,*) '   i-index for control prints (ln_icectl=true)             = ', iiceprt
-         WRITE(numout,*) '   j-index for control prints (ln_icectl=true)             = ', jiceprt
+         WRITE(numout,*) '   Ice thermodynamics (T) or not (F)            ln_limthd  = ', ln_limthd
+         WRITE(numout,*) '   Ice dynamics       (T) or not (F)            ln_limdyn  = ', ln_limdyn
+         WRITE(numout,*) '     (ln_limdyn=T) Ice dynamics switch          nn_limdyn  = ', nn_limdyn
+         WRITE(numout,*) '       2: total'
+         WRITE(numout,*) '       1: advection only (no diffusion, no ridging/rafting)'
+         WRITE(numout,*) '       0: advection only (as 1 + prescribed velocity, bypass rheology)'
+         WRITE(numout,*) '     (ln_limdyn=T) prescribed u-vel (case nn_limdyn=0)     = ', rn_uice
+         WRITE(numout,*) '     (ln_limdyn=T) prescribed v-vel (case nn_limdyn=0)     = ', rn_vice
+         WRITE(numout,*)
+         WRITE(numout,*) '...and ice diagnostics'
+         WRITE(numout,*) ' ~~~~~~~~~~~~~~~~~~~~'
+         WRITE(numout,*) '   Diagnose online heat/mass/salt budget     ln_limdiachk  = ', ln_limdiachk
+         WRITE(numout,*) '   Output          heat/mass/salt budget     ln_limdiahsb  = ', ln_limdiahsb
+         WRITE(numout,*) '   control prints in ocean.out for (i,j)=(iiceprt,jiceprt) = ', ln_limctl
+         WRITE(numout,*) '   i-index for control prints (ln_limctl=true)             = ', iiceprt
+         WRITE(numout,*) '   j-index for control prints (ln_limctl=true)             = ', jiceprt
       ENDIF
       !
       ! sea-ice timestep and inverse
-      rdt_ice   = nn_fsbc * rdt  
+      rdt_ice   = REAL(nn_fsbc) * rdt  
       r1_rdtice = 1._wp / rdt_ice 
 
@@ -381,6 +440,8 @@
       !
 #if defined key_bdy
-      IF( lwp .AND. ln_limdiahsb )  CALL ctl_warn('online conservation check activated but it does not work with BDY')
+      IF( lwp .AND. ln_limdiachk )  CALL ctl_warn('online conservation check activated but it does not work with BDY')
 #endif
+      !
+      IF( lwp ) WRITE(numout,*) '   ice timestep rdt_ice  = ', rdt_ice
       !
    END SUBROUTINE ice_run
@@ -404,18 +465,18 @@
       !
       REWIND( numnam_ice_ref )              ! Namelist namiceitd in reference namelist : Parameters for ice
-      READ  ( numnam_ice_ref, namiceitd, IOSTAT = ios, ERR = 903)
-903   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namiceitd in reference namelist', lwp )
-      !
+      READ  ( numnam_ice_ref, namiceitd, IOSTAT = ios, ERR = 905)
+905   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namiceitd in reference namelist', lwp )
+
       REWIND( numnam_ice_cfg )              ! Namelist namiceitd in configuration namelist : Parameters for ice
-      READ  ( numnam_ice_cfg, namiceitd, IOSTAT = ios, ERR = 904 )
-904   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namiceitd in configuration namelist', lwp )
-      IF(lwm) WRITE( numoni, namiceitd )
+      READ  ( numnam_ice_cfg, namiceitd, IOSTAT = ios, ERR = 906 )
+906   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namiceitd in configuration namelist', lwp )
+      IF(lwm) WRITE ( numoni, namiceitd )
       !
       IF(lwp) THEN                        ! control print
          WRITE(numout,*)
-         WRITE(numout,*) 'ice_itd : ice cat distribution'
-         WRITE(numout,*) ' ~~~~~~'
-         WRITE(numout,*) '   shape of ice categories distribution                     nn_catbnd = ', nn_catbnd
-         WRITE(numout,*) '   mean ice thickness in the domain (used if nn_catbnd=2)   rn_himean = ', rn_himean
+         WRITE(numout,*) 'lim_itd_init : Initialization of ice cat distribution '
+         WRITE(numout,*) '~~~~~~~~~~~~'
+         WRITE(numout,*) '   shape of ice categories distribution                          nn_catbnd = ', nn_catbnd
+         WRITE(numout,*) '   mean ice thickness in the domain (only active if nn_catbnd=2) rn_himean = ', rn_himean
       ENDIF
       !
@@ -423,8 +484,4 @@
       !- Thickness categories boundaries 
       !----------------------------------
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) 'lim_itd_init : Initialization of ice cat distribution '
-      IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~'
-      !
       hi_max(:) = 0._wp
       !
@@ -463,6 +520,5 @@
 
    
-   SUBROUTINE ice_lim_flx( ptn_ice , palb_ice, pqns_ice ,    &
-      &                    pqsr_ice, pdqn_ice, pevap_ice, pdevap_ice, k_limflx )
+   SUBROUTINE ice_lim_flx( ptn_ice, palb_ice, pqns_ice, pqsr_ice, pdqn_ice, pevap_ice, pdevap_ice, k_limflx )
       !!---------------------------------------------------------------------
       !!                  ***  ROUTINE ice_lim_flx  ***
@@ -557,5 +613,6 @@
       u_ice_b(:,:)     = u_ice(:,:)
       v_ice_b(:,:)     = v_ice(:,:)
-      !      
+      at_i_b (:,:)     = SUM( a_i_b(:,:,:), dim=3 )
+      
    END SUBROUTINE sbc_lim_bef
 
@@ -569,5 +626,5 @@
       !!----------------------------------------------------------------------
       sfx    (:,:) = 0._wp   ;
-      sfx_bri(:,:) = 0._wp   ; 
+      sfx_bri(:,:) = 0._wp   ;   sfx_lam(:,:) = 0._wp
       sfx_sni(:,:) = 0._wp   ;   sfx_opw(:,:) = 0._wp
       sfx_bog(:,:) = 0._wp   ;   sfx_dyn(:,:) = 0._wp
@@ -580,6 +637,6 @@
       wfx_bom(:,:) = 0._wp   ;   wfx_sum(:,:) = 0._wp
       wfx_res(:,:) = 0._wp   ;   wfx_sub(:,:) = 0._wp
-      wfx_spr(:,:) = 0._wp   ;   
-      !
+      wfx_spr(:,:) = 0._wp   ;   wfx_lam(:,:) = 0._wp  
+      
       hfx_thd(:,:) = 0._wp   ;   
       hfx_snw(:,:) = 0._wp   ;   hfx_opw(:,:) = 0._wp
@@ -597,5 +654,7 @@
       diag_heat(:,:) = 0._wp ;   diag_smvi(:,:) = 0._wp ;
       diag_vice(:,:) = 0._wp ;   diag_vsnw(:,:) = 0._wp ;
-      !
+
+      tau_icebfr(:,:) = 0._wp; ! landfast ice param only (clem: important to keep the init here)
+      
    END SUBROUTINE sbc_lim_diag0
 
Index: branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90
===================================================================
--- branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 7308)
+++ branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 7309)
@@ -115,14 +115,18 @@
       !
       !                          ! overwrite namelist parameter using CPP key information
-      IF( Agrif_Root() ) THEN                ! AGRIF zoom
-        IF( lk_lim2 )   nn_ice      = 2
-        IF( lk_lim3 )   nn_ice      = 3
-        IF( lk_cice )   nn_ice      = 4
-      ENDIF
-      IF( cp_cfg == 'gyre' ) THEN            ! GYRE configuration
-          ln_ana      = .TRUE.   
-          nn_ice      =   0
-      ENDIF
-      !
+#if defined key_agrif
+      IF( Agrif_Root() ) THEN                ! AGRIF zoom (cf r1242: possibility to run without ice in fine grid)
+         IF( lk_lim2 )   nn_ice      = 2
+         IF( lk_lim3 )   nn_ice      = 3
+         IF( lk_cice )   nn_ice      = 4
+      ENDIF
+#else
+      IF( lk_lim2 )   nn_ice      = 2
+      IF( lk_lim3 )   nn_ice      = 3
+      IF( lk_cice )   nn_ice      = 4     
+#endif
+
+      IF( cp_cfg == 'gyre' )   ln_ana = .TRUE.          ! GYRE configuration
+             
       IF(lwp) THEN               ! Control print
          WRITE(numout,*) '        Namelist namsbc (partly overwritten with CPP key setting)'
@@ -200,6 +204,4 @@
 
       !                                            ! restartability   
-      IF( ( nn_ice == 2 .OR. nn_ice ==3 ) .AND. .NOT.( ln_blk_clio .OR. ln_blk_core .OR. ln_cpl ) )   &
-         &   CALL ctl_stop( 'LIM sea-ice model requires a bulk formulation or coupled configuration' )
       IF( nn_ice == 4 .AND. .NOT.( ln_blk_core .OR. ln_cpl ) )   &
          &   CALL ctl_stop( 'CICE sea-ice model requires ln_blk_core or ln_cpl' )
Index: branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfric.F90
===================================================================
--- branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfric.F90	(revision 7308)
+++ branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfric.F90	(revision 7309)
@@ -205,5 +205,5 @@
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1
-               IF( fsdept(ji,jj,jk) < ekm_dep(ji,jj) ) THEN
+               IF( gdept_n(ji,jj,jk) < ekm_dep(ji,jj) ) THEN
                   avmv(ji,jj,jk) = MAX( avmv(ji,jj,jk), rn_wvmix )
                   avmu(ji,jj,jk) = MAX( avmu(ji,jj,jk), rn_wvmix )
Index: branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/lib_fortran.F90
===================================================================
--- branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/lib_fortran.F90	(revision 7308)
+++ branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/lib_fortran.F90	(revision 7309)
@@ -25,5 +25,5 @@
 
    PUBLIC   glob_sum      ! used in many places (masked with tmask_i)
-   PUBLIC   glob_sum_full ! used in many places (masked with tmask_h, ie omly over the halos)
+   PUBLIC   glob_sum_full ! used in many places (masked with tmask_h, ie only over the halos)
    PUBLIC   DDPDD         ! also used in closea module
    PUBLIC   glob_min, glob_max
Index: branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90
===================================================================
--- branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 7308)
+++ branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 7309)
@@ -104,5 +104,5 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.7 , NEMO Consortium (2015)
+   !! NEMO/OPA 3.7 , NEMO Consortium (2016)
    !! $Id$
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -141,5 +141,8 @@
 # endif
 # if defined key_lim2
-      CALL Agrif_Declare_Var_lim2  !  "      "   "   "      "  LIM
+      CALL Agrif_Declare_Var_lim2  !  "      "   "   "      "  LIM2
+# endif
+# if defined key_lim3
+      CALL Agrif_Declare_Var_lim3  !  "      "   "   "      "  LIM3
 # endif
 #endif
Index: branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/SAS_SRC/daymod.F90
===================================================================
--- branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/SAS_SRC/daymod.F90	(revision 7308)
+++ branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/SAS_SRC/daymod.F90	(revision 7309)
@@ -268,5 +268,9 @@
 
       ! since we no longer call rst_opn, need to define nitrst here, used by ice restart routine
-      IF( kt == nit000 ) nitrst = nitend
+      IF( kt == nit000 )  THEN
+         nitrst = nitend
+         lrst_oce = .FALSE.  ! init restart ocean (done in rst_opn when not SAS)
+      ENDIF
+
       IF( MOD( kt - 1, nstock ) == 0 ) THEN
          ! we use kt - 1 and not kt - nit000 to keep the same periodicity from the beginning of the experiment
